defmodule Nulla.Repo.Migrations.CreateActors do
  use Ecto.Migration

  def change do
    create table(:actors, primary_key: false) do
      add :id, :bigint, primary_key: true
      add :acct, :string
      add :ap_id, :string
      add :type, :string
      add :following, :string
      add :followers, :string
      add :inbox, :string
      add :outbox, :string
      add :featured, :string
      add :featuredTags, :string
      add :preferredUsername, :string
      add :name, :string
      add :summary, :string
      add :url, :string
      add :manuallyApprovesFollowers, :boolean, default: false, null: false
      add :discoverable, :boolean, default: true, null: false
      add :indexable, :boolean, default: true, null: false
      add :published, :utc_datetime
      add :memorial, :boolean, default: false, null: false
      add :publicKey, :map
      add :privateKeyPem, :text
      add :tag, {:array, :map}, default: []
      add :attachment, {:array, :map}, default: []
      add :endpoints, :map
      add :icon, :map
      add :image, :map
      add :vcard_bday, :date
      add :vcard_Address, :string

      timestamps(type: :utc_datetime)
    end

    create unique_index(:actors, [:acct])
    create unique_index(:actors, [:ap_id])
  end
end
